/*
Copyright (c) 1997-2000, KeeBoo Corporation. All rights reserved.
Copyright application on progress at the Copyright Office.
Patents pending PCT/FR98/00916 and PCT/FR98/00917.
This source code is the property of KeeBoo Corporation,
it cannot be reused, modified or published without prior 
written consent from KeeBoo Corporation.
KeeBoo and the KeeBoo logo are trademarks or registered
trademarks of KeeBoo Corporation.
*/

var _engineVersion = '2.1'
var _docVersion = '2.1'
var _docVersionLabel = '2.1'
var _neutral = ''
var _localized = ''
var _contents = ''
var _root = ''
var _tabs = ''
var _common = ''
var _audience = false
var _langName = ''
var _lookName = ''
var _searchWord = ''
var _found = new Array()
var _Book = new Book
var _MAX_CHAPTER = 11
var _keebooTopFrameset = 'here'
var _partner = _NULL

var _page = new Array
_page["left"] = new PageInfo
_page["right"] = new PageInfo

function setDocVersion(version, versionLabel)
{
	_docVersion = version
	_docVersionLabel = versionLabel
}

function PageInfo()
{
	this.url = ''
	this.title = ''
	this.timer = _NULL
	this.external = false
	this.navigate = false
}

function putInfoCB()
{
	setCookie('book_' + WebBookID, _Book.page + '"' + _Book.mode, 30)
}

function Book_init(common, look, lang, contents, audience, langName, lookName, partner)
{
	if (!checkBrowser())
		alert(_Labels['browserWarning'])

	_root = getPath(document)
	_common = calculatePath(_root, common)
	_localized = calculatePath(_root, lang)
	_neutral = calculatePath(_root, look)
	_contents = calculatePath(_root, contents)
	_tabs = _neutral
	_audience = audience == _NULL ? false : audience
	_langName = langName
	_lookName = lookName
	_partner = partner

	var pageCookie = _NULL
	var modeCookie = _NULL
	var theCookie= getCookie('book_' + WebBookID)
	if (theCookie != _NULL)
	{
		var cookieTab = theCookie.split('"')
		if (cookieTab.length >= 2)
		{
			pageCookie = cookieTab[0]
			modeCookie = cookieTab[1]
		}
	}

	this.mode = location.search.substring(1,2)
	this.page = location.search.substring(2)

	if (this.mode == '')
	{
		if (modeCookie != _NULL)
			this.mode = parseInt(modeCookie)
		else
			this.mode = 2
	}
	else
		this.mode = parseInt(this.mode)

	if (this.page == '')
	{
		if (pageCookie != _NULL)
			this.page = Math.min(book.pages.length - this.mode, parseInt(pageCookie))
		else
			this.page = 0
	}
	else
		this.page = parseInt(this.page)

	if (_partner != _NULL)
	{
		_Labels['limitText'] = formatString(limit1Partner, _partner) + limit2 + formatString(limit3Partner, _partner)
		_Labels['authorDisclamer'] = disc1 + formatString(disc2Partner, _partner) + disc3
	}

	with (book.branding)
	{
		logoPath = calculatePath(_contents, logoPath, false)
		indexPath = calculatePath(_contents, indexPath, false)
		tocPath = calculatePath(_contents, tocPath, false)
		logoUrl = parseBranding(logoUrl)
		indexUrl = parseBranding(indexUrl)
		tocUrl = parseBranding(tocUrl)
	}
	
	book.author.photo = calculatePath(_contents, book.author.photo, false)
	
	_Labels['fullCopy'] = formatString(_Labels['fullCopy'], _docVersionLabel)
	_Labels['keeboCreated'] = formatString(_Labels['keeboCreated'], _docVersionLabel)
}

function getStyleHTML(optional)
{
	optional = (optional == _NULL) ? '' : optional + '\n'

	var str = ''
	for (i in _CommonStyles) str += _CommonStyles[i] + '\n'
	return ('<STYLE TYPE="text/css">\n<!--\n' + str + optional + '-->\n</STYLE>\n')
}

function changePageModeCB()
{
	with (_Book)
	{
		if (mode == 2) page ++
		else page --

		var previousPage = page
		page = Math.max(page, 0)
		page = Math.min(page, book.pages.length - (mode == 2 ? 1 : 2))

		if (_ns || _macIE)
		{
			var loc = document.location.pathname
			if (_moz)
			{
				locSplit = loc.split("?")
				if (locSplit.length > 0)
					loc = locSplit[0]
			}
			document.location.replace(((mode==2) ? loc+"?1" : loc+"?2") + page)
		}
		else
		{
			var theWin = (window == top) ? window.parent : self
			if (mode==2)
			{
				mode = 1
				theWin.firstFrameSet.cols='20,0,55,*,20'
			}
			else
			{
				mode = 2
				theWin.firstFrameSet.cols='20,*,55,*,20'
			}

			if (getFrame('f_base_middle_right').reWrite != _NULL)
				getFrame('f_base_middle_right').reWrite(_Labels[(_Book.mode == 1) ? 'switchTwoPage' : 'switchOnePage'])
		 
			if (mode == 2)
			{
				if (previousPage == -1)
					changePage(page, true)
				else
				{
					if (_page["left"].url != getPageURL(page))
					{
						getPageInfo()
						writeTitleAndPage('left', false)
					}
				}
			}
		}
	}
}

function downloadCB()
{
	window.open(_Labels['keebooURL'])
}

function turnTabsCB(nb, right)
{
	right = (right == _NULL) ? false : right
	with (_Book)
	{
		var newPage = 0
		if (nb == -1)
			newPage = book.pages.length - mode
		else
		{
			newPage = book.tabs[nb]
			if ((right) && (mode == 2))
				newPage = Math.max(0, newPage - 1)
			if ((nb == 0) && (!right) && (mode == 2))
				newPage = 0
		}
		changePage(newPage)
	}
}

function initCB()
{
	updateSurround()
}

function onLoadPageCB(side)
{
	if (_searchWord != '')
	{
		var parentFrame = getPageFrame(side, "content")
		if (parentFrame == _NULL) return

		var _hiddenFrame = getFrame('page', parentFrame)
		if (_hiddenFrame == _NULL) return

		if (!_macIE && !_moz)
			frameSearch(_hiddenFrame, _searchWord, true)
	}
}

function Book()
{
	this.mode = 2
	this.page = 0

	this.init = Book_init
	this.write = Book_write
	this.changePage = Book_changePage
	this.updateTabs = Book_updateTabs
}

function showTab(pos, index, show)
{
	var frame = getFrame(pos == 'left' ? 'f_lefttab_middle' : 'f_righttab_middle')
	if ((frame != _NULL) && (frame.showTab != _NULL)) frame.showTab(index, show)
}

function currentChapterTab()
{
	var currentChapter = 0
	var pageNum = (_Book.mode == 2) ? _Book.page : _Book.page - 1

	for (var i = 0; i < book.tabs.length; i++)
	{
		if (book.tabs[i] > pageNum) break
		else currentChapter++
	}
	return currentChapter
}

function Book_updateTabs()
{
	var currentChapter = currentChapterTab()
	var tabsLen = Math.min(book.tabs.length, _MAX_CHAPTER)

	for (var i = 0; i < tabsLen; i++)
	{
		var beforeChap = (i < currentChapter)
		showTab('left', i, beforeChap)
		showTab('right', i, !beforeChap)
	}
}

function goToWebViaImage(url)
{
	window.open(url+"&ReaderSKU="+ReaderSKU+"&ReaderPartner="+ReaderPartner+"&ReaderUser="+ReaderUser+"&ReaderAutorunCount="+ReaderAutorunCount)
}

function goTo7x(ClickSource,Redirect, url)
{
	url = (url == _NULL) ? _Labels['keebooRedirectURL'] : url
	window.open(url + ClickSource + "&AuthorUser="+AuthorUser+"&ReaderSKU="+ReaderSKU+"&ReaderPartner="+ReaderPartner+"&AuthorSKU="+AuthorSKU+"&AuthorPartner="+AuthorPartner+"&ReaderUser="+ReaderUser+"&ReaderAutorunCount="+ReaderAutorunCount+"&Redirect="+Redirect)
}

function translateLink(linkURL)
{
	for (var i = 0; i < book.pages.length; i++)
		if (linkURL == book.pages[i].url)
		{
			_Book.changePage(i, false)
			return
		}
	window.open(linkURL) 
}

function turnPagesFromTOC(nb)
{
	_Book.changePage(nb, false)
}

function getCookie(name)
{
	var cname = name + "="
	var dc = document.cookie
	if (dc.length > 0) 
	{
		var begin = dc.indexOf(cname)
		if (begin != -1)
		{
			begin += cname.length
			var end = dc.indexOf(";", begin)
			if (end == -1) end = dc.length
				return unescape(dc.substring(begin, end))
		}
	}
	return _NULL
}

function setCookie(name, value, nbDay) 
{
	var today = new Date()
	var expires = new Date(today.getTime() + nbDay * 24 * 60 * 60 * 1000)

	document.cookie = name + "=" + escape(value) + "; path=/" + ((expires == null) ? "" : "; expires=" + expires.toGMTString())
}

function updateSurround()
{
	if (getFrame('f_binder_middle').moveBinder != _NULL)
		getFrame('f_binder_middle').moveBinder()
	_Book.updateTabs()

	if (_ie)
		if (getFrame('f_binder_middle')._Binder != _NULL)
			getFrame('f_binder_middle')._Binder.elem.alt = _Labels['page'] + " " + (_Book.page + 1) + _Labels['pageSeparator'] + book.pages.length
}

function getTitle(item)
{
	switch(item.internal)
	{
		case "author": return _Labels["authorPageTitle"]
		case "index": return _Labels["index"]
		case "advert": return _Labels["whatIs"]
		case "toc": return _Labels["toc"]
	}
	return item.title
}

function getPageTitle(index)
{
	return getTitle(book.pages[index])
}

function getPageURL(index)
{
	switch(book.pages[index].internal)
	{
		case "author": return _common + "author.htm"
		case "index": return _common + "find_frameset.htm"
		case "advert": return _common + "kee_fram.htm"
		case "chapter":
		case "toc": return _common + 'sum_fram.htm'
	}
	var localFile = book.pages[index].fileName	
	if (localFile != "") return _contents + localFile
	else return book.pages[index].url
}

function historyLevel(side)
{
	var frame = getPageFrame(side, "content")
	if (frame == _NULL) return -1
	if (_ns) frame = getFrame('page', frame)
	if (frame == _NULL) return -1

	return frame.history.length
}

function checkExternalCB(side)
{
	if (!_macIE) _page[side].timer = setInterval("checkExternal('" + side + "')", 500)
}

function checkExternal(side)
{
	if (historyLevel(side) > (_moz ? 2 : (_ns || _macIE) ? 1 : 0))
	{
		clearInterval(_page[side].timer)
		_page[side].timer = _NULL
		_page[side].navigate = true
		
		var frame = getPageFrame(side, "top")
		if ((frame != _NULL) && (frame.reWrite != _NULL))	frame.reWrite()
	}
}

function returnToBook(side)
{
	fillPageInfo(side, _Book.page + _Book.mode - (side == "left" ? 2 : 1))
	writeTitleAndPage(side, false)
}

function pageTitleString(side)
{
	if ((_page[side].external) && (_page[side].navigate == true))
	{
		return '<table class=pageExt width=100% cellspacing=0 cellpadding=0 border=0><tr valign=top><td align=left><span class=pageExt>' + _Labels['extLeft'] + '</span></td><td align=right><span class=pageExt>' + 
		"<a href='" + "javascript:parent.returnToBook(\"" + side + "\")'" + "'>" + _Labels['extRight'] + '</a></span></td></tr></table>'		
	}
	else
	{
		var page = '&nbsp;' + (_Book.page + _Book.mode - (side == "left" ? 1 : 0)) + '/' + (book.pages.length)
		if (_macIE) return '<span class=pageTitle>' + _page[side].title + "&nbsp;&nbsp;&nbsp;" + page + '</span>'
		else return '<table width=100% cellspacing=0 cellpadding=0 border=0><tr valign=top><td align=left><span class=pageTitle>' + _page[side].title + '</span></td><td align=right><span class=pageTitle>' + page + '</span></td></tr></table>'
	}
}

function fillPageInfo(side, index)
{
	with(_page[side])
	{
		title = getPageTitle(index)
		url = getPageURL(index)
		external = (book.pages[index].fileName == "")
		
		if (timer != _NULL)
		{
			clearInterval(timer)
			timer = _NULL
		}
		
		if (external && !_macIE) navigate = false
	}
}

function getPageInfo()
{
	with (_Book)
	{
		if (mode == 2)
		{
			fillPageInfo("left", page)
			fillPageInfo("right", page + 1)
		}
		else fillPageInfo("right", page)
	}
}

function getPageFrame(side, frameType)
{
	return getFrame("f_" + side + (frameType == "top" ? "page_top" : "page"))
}

function getPageRealUrl(side, init, fromFind)
{
	with(_page[side])
	{
		if (external) return _common + side + "_ext.htm"
		if ((init && _ns) || ((fromFind) && (side == "right"))) return _common + side + "page.htm"
		return url
	}
}

function writeTitleAndPage(side, fromFind)
{
	var frame = getPageFrame(side, "top")
	if ((frame != _NULL) && (frame.reWrite != _NULL))	frame.reWrite()
	changeFrameURL(getPageFrame(side, "content"), getPageRealUrl(side, false, fromFind))
}

function Book_changePage(newPage, force, fromFind)
{
	with (this)
	{
		if ((newPage < 0) || (newPage >= (book.pages.length - mode + 1))) return

		force = (force == _NULL) ? false : force
		fromFind = (fromFind == _NULL) ? false : fromFind

		if ((newPage != page) || force)
		{
			page = newPage
			getPageInfo()

			if (mode == 2) writeTitleAndPage('left', fromFind)
			writeTitleAndPage('right', fromFind)
			updateSurround() 
		}
	}
}

function buildFrame(name)
{
	return startFrame("f_" + name, _common + name + ".htm")
}

function Book_write()
{
	if (_ie)
	{
		if ((window.external != _NULL) && (window.external.provider != _NULL) && (window.external.provider.name == "KeeBoo"))
		document.write(startFrameSet('*,0') + startFrame('f_import', _common + 'import.htm', "auto") + endFrameSet())
		document.close()
	}

	getPageInfo()
	var str = startFrameSet('*,22', _NULL, 'initCB()', 'putInfoCB()')

	if (_ie) str += startFrameSet(_NULL, (this.mode == 1) ? '20,0,55,*,20' : '20,*,55,*,20', _NULL, _NULL, 'firstFrameSet')
	else str += startFrameSet(_NULL, (this.mode == 1) ? '20,55,*,20' : '20,*,55,*,20', _NULL, _NULL, 'firstFrameSet')

	str += startFrameSet('*, 30')
	str += buildFrame("lefttab_middle")
	str += buildFrame("lefttab_bottom")
	str += endFrameSet()

	if ((this.mode == 2) || (_ie))
	{
		str += startFrameSet('30,*')
		str += buildFrame("leftpage_top")
		str += startFrame('f_leftpage', getPageRealUrl("left", true, false), 'auto')
		str += endFrameSet()
	}

	str += startFrameSet('30,*,23')
	str += buildFrame("binder_top")
	str += buildFrame("binder_middle")
	str += buildFrame("binder_bottom")
	str += endFrameSet()

	str += startFrameSet('30,*')
	str += buildFrame("rightpage_top")
	str += startFrame('f_rightpage', getPageRealUrl("right", true, false), 'auto')
	str += endFrameSet()

	str += startFrameSet('*,55')
	str += buildFrame("righttab_middle")
	str += buildFrame("righttab_bottom")
	str += endFrameSet()
	str += endFrameSet()

	str += startFrameSet(_NULL, '*,*,42')
	str += buildFrame("base_middle_left")
	str += buildFrame("base_middle_right")
	str += buildFrame("base_right")
	str += endFrameSet()
	str += endFrameSet()

	str += ('<noframes><body><p>' + _Labels['noFrames'] + '</p></body></noframes>')
	document.write(str)
	document.close()
}

function parseBranding(url)
{
	if (url.indexOf("WebBookID=") == -1) return url + ((url.indexOf("?") == -1) ? "?" : "&") + "WebBookID="+ WebBookID
	else return url
}
